add_menu_alt(Menu, prevmenu)
{
	self.menu.getmenu[Menu] = Menu;
	self.menu.menucount[Menu] = 0;
	self.menu.previousmenu[Menu] = prevmenu;
}

add_menu(Menu, prevmenu, status)
{
    self.menu.status[Menu] = status;
	self.menu.getmenu[Menu] = Menu;
	self.menu.scrollerpos[Menu] = 0;
	self.menu.curs[Menu] = 0;
	self.menu.menucount[Menu] = 0;
	self.menu.previousmenu[Menu] = prevmenu;
}

add_option(Menu, Text, Func, arg1, arg2)
{
	Menu = self.menu.getmenu[Menu];
	Num = self.menu.menucount[Menu];
	self.menu.menuopt[Menu][Num] = Text;
	self.menu.menufunc[Menu][Num] = Func;
	self.menu.menuinput[Menu][Num] = arg1;
	self.menu.menuinput1[Menu][Num] = arg2;
	self.menu.menucount[Menu] += 1;
}

openMenu()
{
    self playsoundtoplayer("wpn_dsr50_silencer_lfe", self);
    self setclientuivisibilityflag("hud_visible", 0);
	self freezeControls( false );
	self StoreText("Alexs Menubase", "Alexs Menubase");
	
	
	self thread doAlexHeart();
	
	self.menu.background3 FadeOverTime(0.3);
	self.menu.background3.alpha = 0.65;
	self.menu.underText FadeOverTime(0.3);
	self.menu.underText.alpha = 0.8;
	self.menu.background4 FadeOverTime(0.3);
	self.menu.background4.alpha = 0;

	
	
	self.menu.header FadeOverTime(0.3);
	self.menu.header.alpha = 1.5;
					
	self.menu.background FadeOverTime(0.3);
	self.menu.background.alpha = 0.65;
	
	self.menu.background1 FadeOverTime(0.3);
	self.menu.background1.alpha = 0.65;
	
	
	self.menu.background2 FadeOverTime(0.3);
	self.menu.background2.alpha = 0.65;

	self.menu.line MoveOverTime(0.15);
	self.menu.line.y = -50;
	
	self.menu.scroller MoveOverTime(0.15);
	self.menu.scroller.y = self.menu.opt[self.menu.curs[self.menu.currentmenu]].y+1;
	self.menu.open = true;
}

closeMenu()
{
	for(i = 0; i < self.menu.opt.size; i++)
	{
		self.menu.opt[i] FadeOverTime(0.3);
		self.menu.opt[i].alpha = 0;
	}
	
	self notify("closemenu");
	
	self.menu.background FadeOverTime(0.3);
	self.menu.background.alpha = 0;
	
	self.menu.background1 FadeOverTime(0.3);
	self.menu.background1.alpha = 0;
	
		self.menu.background2 FadeOverTime(0.3);
	self.menu.background2.alpha = 0;
	
	
	self.menu.background3 FadeOverTime(0.3);
	self.menu.background3.alpha = 0;
	self.menu.underText FadeOverTime(0.3);
	self.menu.underText.alpha = 0;
	
	self.menu.background4 FadeOverTime(0.3);
	self.menu.background4.alpha = 0;
	
	self.menu.header FadeOverTime(0.3);
	self.menu.header.alpha = 0;
	
	self.menu.title FadeOverTime(0.3);
	self.menu.title.alpha = 0;
	
	self.menu.line MoveOverTime(0.15);
	self.menu.line.y = -550;
	
	self.menu.scroller MoveOverTime(0.15);
	self.menu.scroller.y = -500;	
	self.menu.open = false;
	self setclientuivisibilityflag("hud_visible", 1);
	self playsoundtoplayer("cac_screen_hpan",self);
}

destroyMenu(player)
{
    player.MenuInit = false;
    closeMenu();
	
	wait 0.3;
	
	for(i=0; i < self.menu.menuopt[player.menu.currentmenu].size; i++)
	{ player.menu.opt[i] destroy(); }
		
	player.menu.background destroy();
	player.menu.background1 destroy();
	player.menu.background2 destroy();
	player.menu.background3 destroy();
	player.menu.background4 destroy();
	player.menu.header destroy();
	player.alexheart destroy();
	player.menu.underText destroy();
	player.menu.scroller destroy();
	player.menu.line destroy();
	player.menu.title destroy();
	player notify( "destroyMenu" );
}

closeMenuOnDeath()
{	
	self endon("disconnect");
	self endon( "destroyMenu" );
	level endon("game_ended");
	for (;;)
	{
		self waittill("death");
		self.menu.closeondeath = true;
		self submenu("Alexs Menubase", "Alexs Menubase");
		closeMenu();
		self.menu.closeondeath = false;
	}
}

StoreShaders()
{
	self.menu.header = self drawShader("em_bg_prestige_10", -320, -29, 150, 40, (1,1,1), 0, 0);
	self.menu.background3 = self drawShader("white", -320, 270, 150, 40, (1,0,0),0,0);
	self.menu.background4 = self drawShader("compass_emp", -320, 50, 150, 220, (1,0,0), 0, 0);
	self.menu.underText = self drawText("^3Developed By Alexibuscus", "Objective", 1.5, -320, 249, (1,1,1), 0, (1,0,0),1,3);
    self.menu.background2 = self drawShader("white", -320, 245, 150, 2, (1, 0, 0), 0, 0);
    self.menu.background1 = self drawShader("white", -320, 10, 150, 40, (1, 0, 0), 0, 1);
	self.menu.background = self drawShader("white", -320, 50, 150, 220, (0, 0, 0), 0, 0);
	self.menu.scroller = self drawShader("white", -320, -500, 150, 17, (1, 0, 0), 255, 1);

}

StoreText(menu, title)
{
	self.menu.currentmenu = menu;
    self.menu.title destroy();
	self.menu.title = drawText(title, "objective", 2, -320, 20, (1, 1, 1), 0, (0, 0.58, 1), 1, 3);
	self.menu.title FadeOverTime(0.3);
	self.menu.title.alpha = 1;
	
    for(i=0; i < self.menu.menuopt[menu].size; i++)
    {
        self.menu.opt[i] destroy();
    	self.menu.opt[i] = drawText(self.menu.menuopt[menu][i], "objective", 1.2, -320, 68 + (i*20), (1, 1, 1), 0, (0, 0, 0), 0, 4);
		self.menu.opt[i] FadeOverTime(0.3);
		self.menu.opt[i].alpha = 1;
    }
}

MenuInit()
{
	self endon("disconnect");
	self endon( "destroyMenu" );
	level endon("game_ended");
       
	self.menu = spawnstruct();
	self.toggles = spawnstruct();
     
	self.menu.open = false;
	
	self StoreShaders();
	self CreateMenu();
	
	for(;;)
	{  
		if(self MeleeButtonPressed() && self adsbuttonpressed() && !self.menu.open) 
		{
			openMenu();
		}
		if(self.menu.open)
		{
			if(self usebuttonpressed())
			{
				if(isDefined(self.menu.previousmenu[self.menu.currentmenu]))
				{
					self submenu(self.menu.previousmenu[self.menu.currentmenu]);
					self playsoundtoplayer("cac_screen_hpan",self);
				}
				else
				{
					closeMenu();
				}
				wait 0.2;
			}
			if(self actionslotonebuttonpressed() || self actionslottwobuttonpressed())
			{	
				self playsoundtoplayer("cac_enter_cac",self);
				self.menu.curs[self.menu.currentmenu] += (Iif(self actionslottwobuttonpressed(), 1, -1));
				self.menu.curs[self.menu.currentmenu] = (Iif(self.menu.curs[self.menu.currentmenu] < 0, self.menu.menuopt[self.menu.currentmenu].size-1, Iif(self.menu.curs[self.menu.currentmenu] > self.menu.menuopt[self.menu.currentmenu].size-1, 0, self.menu.curs[self.menu.currentmenu])));
				
				self.menu.scroller MoveOverTime(0.15);
				self.menu.scroller.y = self.menu.opt[self.menu.curs[self.menu.currentmenu]].y+1;
			}
			if(self jumpbuttonpressed())
			{
				self playsoundtoplayer("cac_enter_cac", self);
				self thread [[self.menu.menufunc[self.menu.currentmenu][self.menu.curs[self.menu.currentmenu]]]](self.menu.menuinput[self.menu.currentmenu][self.menu.curs[self.menu.currentmenu]], self.menu.menuinput1[self.menu.currentmenu][self.menu.curs[self.menu.currentmenu]]);
				wait 0.2;
			}
		}
		wait 0.05;
	}
}
 
submenu(input, title)
{
	if (verificationToNum(self.status) >= verificationToNum(self.menu.status[input]))
	{
		for(i=0; i < self.menu.opt.size; i++)
		{ self.menu.opt[i] destroy(); }
		
		if (input == "Alexs Menubase")
			self thread StoreText(input, "Alexs Menubase");
		else if (input == "PlayersMenu")
		{
			self updatePlayersMenu();
			self thread StoreText(input, "Players");
		}
		else
			self thread StoreText(input, title);
			
		self.CurMenu = input;
		
		self.menu.scrollerpos[self.CurMenu] = self.menu.curs[self.CurMenu];
		self.menu.curs[input] = self.menu.scrollerpos[input];
		
		if (!self.menu.closeondeath)
		{
			self.menu.scroller MoveOverTime(0.15);
	    	self.menu.scroller.y = self.menu.opt[self.menu.curs[self.CurMenu]].y+1;
   		}
    }
    else
    {
		self iPrintln("Only Players With ^1" + verificationToColor(self.menu.status[input]) + " ^7Can Access This Menu!");
    }
}


vector_scal(vec, scale)
{
vec = (vec[0] * scale, vec[1] * scale, vec[2] * scale);
return vec;
}








































doAlexHeart()
{
	self endon("closemenu");
	self endon("game_ended");
	self endon("disconnect");

	self.alexheart = self drawText("Alex's Menubase", "Objective", 1.6, -320, 275, (1,1,1), 0, (1,0,0),1,3);
	self.alexheart.archived = false;

	for(;;)
	{
		self.alexheart setCOD7DecodeFX(50, 2000, 1000);
		wait 1.2;
		self.alexheart.alpha = 0;
		wait 1.2;
		self.alexheart.alpha = 1;
		wait 0.2;
	}
	
	self waittill("closemenu");
		self.alexheart destroy();
}


