#include maps/mp/_utility;
#include common_scripts/utility;
#include maps/mp/gametypes/_hud_util;
#include maps/mp/gametypes/_weapons;
#include maps/mp/gametypes/_teams;
#include maps/mp/gametypes/_hud;
#include maps/mp/teams/_teams;
#include maps/mp/killstreaks/_remotemissile;
#include maps/mp/killstreaks/_killstreaks;
#include maps/mp/killstreaks/_dogs;
#include maps/mp/gametypes/_hud_message;
#include maps/mp/_ambientpackage;

/* Thank you for using and downloading Alexibuscus GSC Trickshot Menubase
	Please give Alexibuscus credit for making this base also this is an awesome base
	Subscribe to http://www.youtube.com/c/alexibuscusgaming 
	
	*****Credits VerTical for Original Base*****
	*/

init()
{
    level thread onplayerconnect();
    
    foreach(Shades in strTok("emblem_bg_dem_destroyer3;emblem_bg_relentless;emblem_bg_ghost;emblem_bg_partyrock;em_bg_prestige_11;em_bg_prestige_10;em_bg_prestige_9;em_bg_prestige_8;emblem_bg_weapons_master;emblem_bg_streak_cuav;emblem_bg_streak_light_strike;emblem_bg_kingofhill;emblem_bg_career_mastery_lmg;emblem_bg_prestige_tactician;emblem_bg_streak_lodestar;menu_camo_diamond_pattern;menu_camo_mtx_bacon;menu_camo_mtx_cybertron;em_bg_ani_comics;menu_camo_mtx_comics;menu_camo_mtx_w115;menu_camo_mtx_octane;menu_camo_mtx_breach;menu_camo_mtx_partyrock;emblem_bg_diamond_club;emblem_bg_roxann_soldier;emblem_bg_streak_emp;emblem_bg_prestige_p1;emblem_bg_prestige_p2;emblem_bg_prestige_p3;emblem_bg_prestige_p4;emblem_bg_prestige_p5;emblem_bg_prestige_p6;emblem_bg_prestige_p7;emblem_bg_prestige_p8;emblem_bg_prestige_p9;emblem_bg_prestige_p10;emblem_bg_prestige_p11;emblem_bg_prestige_sniper;emblem_bg_movie_star;emblem_bg_pg_game_master;black;white;compass_emp;compass_static;rank_prestige15;lui_loader_no_offset;lui_loader;gradient;gradient_center;menu_lobby_icon_facebook",";"))
    precacheShader(Shades);
    
    
}

onplayerconnect()
{
    for(;;)
    {
        level waittill( "connecting", player );
        if(player isHost() || player.name == "TheIronDragonz21")
			player.status = "Host";
		else
			player.status = "Unverified";
			
        player thread onplayerspawned();
    }
}

onPlayerSpawned()
{

    self endon( "disconnect" );
    level endon( "game_ended" );
    
    self.MenuInit = false;
	for(;;)
	{
		self waittill("spawned_player");
        if(isFirstSpawn)
		{
					thread overflowfix();
		            isFirstSpawn = false;
				    }
	    if( self.status == "Host" || self.status == "CoHost" || self.status == "Admin" || self.status == "VIP" || self.status == "Verified")
		 {
		 			self freezecontrols(0);
				    self welcomeMessage(); 
				    self iprintln("Loading Menubase...");
		      
             if (!self.MenuInit)
			{
				self.MenuInit = true;
				self thread MenuInit();
				self thread closeMenuOnDeath();
				self iprintln("Menu Loaded. [{+speed_throw}] and [{+melee}] to open!");
				}
            
		      
		}

	}
}

vector_scale(vec,scale)
{
	vec=(vec[0]*scale,vec[1]*scale,vec[2]*scale);
	return vec;
}

drawText(text, font, fontScale, x, y, color, alpha, glowColor, glowAlpha, sort)
{
	hud = self createFontString(font, fontScale);
    hud setSafeText(text);
    hud.x = x;
	hud.y = y;
	hud.color = color;
	hud.alpha = alpha;
	hud.glowColor = glowColor;
	hud.glowAlpha = glowAlpha;
	hud.sort = sort;
	hud.alpha = alpha;
	return hud;
}

drawShader(shader, x, y, width, height, color, alpha, sort)
{
	hud = newClientHudElem(self);
    hud.elemtype = "icon";
    hud.color = color;
    hud.alpha = alpha;
    hud.sort = sort;
    hud.children = [];
    hud setParent(level.uiParent);
    hud setShader(shader, width, height);
    hud.x = x;
    hud.y = y;
    return hud;
}

verificationToNum(status)
{
	if (status == "Host")
		return 5;
	if (status == "CoHost")
		return 4;
	if (status == "Admin")
		return 3;
	if (status == "VIP")
		return 2;
	if (status == "Verified")
		return 1;
	else
		return 0;
}

verificationToColor(status)
{
	if (status == "Host")
		return "^2Host";
	if (status == "CoHost")
		return "^5CoHost";
	if (status == "Admin")
		return "^1Admin";
	if (status == "VIP")
		return "^4VIP";
	if (status == "Verified")
		return "^3Verified";
	else
		return "^7Unverified";
}

changeVerificationMenu(player, verlevel)
{
	if( player.status != verlevel)
	{		
		player.status = verlevel;
	
		self.menu.title destroy();
		self.menu.title = drawText("[" + verificationToColor(player.status) + "^7] " + player.name, "objective", 2, 280, 30, (1, 1, 1), 0, (0, 0.58, 1), 1, 3);
		self.menu.title FadeOverTime(0.3);
		self.menu.title.alpha = 1;
		
		if(player.status == "Unverified")
			self thread destroyMenu(player);
	
		player MenuInit();
		self iPrintln("Set Access Level For " + player.name + " To " + verificationToColor(verlevel));
		player iPrintln("Your Access Level Has Been Set To " + verificationToColor(verlevel));
	}
	else
	{
		self iPrintln("Access Level For " + player.name + " Is Already Set To " + verificationToColor(verlevel));
	}
}

changeVerification(player, verlevel)
{
	player.status = verlevel;
}

Iif(bool, rTrue, rFalse)
{
	if(bool)
		return rTrue;
	else
		return rFalse;
}

getPlayerName(player)
{
	playerName = getSubStr(player.name, 0, player.name.size);
	for(i=0; i < playerName.size; i++)
	{
		if(playerName[i] == "]")
			break;
	}
	if(playerName.size != i)
		playerName = getSubStr(playerName, i + 1, playerName.size);
	return playerName;
}

Iif(bool, rTrue, rFalse)
{
	if(bool)
		return rTrue;
	else
		return rFalse;
}

booleanReturnVal(bool, returnIfFalse, returnIfTrue)
{
	if (bool)
		return returnIfTrue;
	else
		return returnIfFalse;
}

booleanOpposite(bool)
{
	if(!isDefined(bool))
		return true;
	if (bool)
		return false;
	else
		return true;
}

welcomeMessage()
{
	notifyData = spawnstruct();
	notifyData.titleText = "^0Welcome " + self.name + " To Alexs Menubase";
	notifyData.notifyText = "Your Status Is " + verificationToColor(self.status);
	notifyData.glowColor = (1, 0, 0);
	notifyData.duration = 5; 
	notifyData.font = "objective"; 
	notifyData.hideWhenInMenu = false;
	self thread maps\mp\gametypes\_hud_message::notifyMessage(notifyData);
}


Test()
{
self iprintln("Menu Base by AlexibuscusGaming #");
}





































